using System;
using System.Reflection;
using System.IO;

class AssemblyDoubleLoad
{
	static private void ShowAllAsemblies()
	{
		foreach(Assembly assembly in AppDomain.CurrentDomain.GetAssemblies())
		{
			Console.WriteLine(assembly.FullName);
			Console.WriteLine(assembly.Location);
			Console.WriteLine();
		}
	}

	static void Main(string[] args)
	{
		// List all assemblies at the beginning
		Console.WriteLine(" ------------------- In the beginning --------------------");
		ShowAllAsemblies();

		// Load mscorlib.dll with Assembly.Load() and list all asemblies
		Assembly.Load("mscorlib.dll");
		Console.WriteLine("------ After loading Mscorlib with Assembly.Load() ------");
		ShowAllAsemblies(); 

		// Load mscorlib.dll from a different path 
		Assembly.LoadFrom(@"..\..\mscorlib.dll");
		Console.WriteLine(" --- After loading mscorlib.dll from a different path ---");
		ShowAllAsemblies();
	}
}
